"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const web3_js_1 = require("@solana/web3.js");
const __1 = require("../..");
const fs = __importStar(require("fs"));
const os = __importStar(require("os"));
const config_1 = require("../../config");
const bn_js_1 = require("bn.js");
const config = new config_1.Config(__1.IDS);
const cluster = (process.env.CLUSTER || 'devnet');
const groupName = process.env.GROUP || 'devnet.3';
const marketIndex = 5;
const groupIds = config.getGroup(cluster, groupName);
const payer = web3_js_1.Keypair.fromSecretKey(Uint8Array.from(JSON.parse(process.env.PRIVATE_KEY ||
    fs.readFileSync(process.env.KEYPAIR || os.homedir() + '/.config/solana/devnet.json', 'utf-8'))));
function setMarketMode() {
    return __awaiter(this, void 0, void 0, function* () {
        const connection = new web3_js_1.Connection(config.cluster_urls[cluster]);
        const client = new __1.MangoClient(connection, groupIds.mangoProgramId);
        const setMarketModeTx = new web3_js_1.Transaction().add((0, __1.makeSetMarketModeInstruction)(groupIds.mangoProgramId, groupIds.publicKey, payer.publicKey, new bn_js_1.BN(marketIndex), __1.MarketMode.CloseOnly, __1.AssetType.Token), (0, __1.makeSetMarketModeInstruction)(groupIds.mangoProgramId, groupIds.publicKey, payer.publicKey, new bn_js_1.BN(marketIndex), __1.MarketMode.ForceCloseOnly, __1.AssetType.Token));
        yield client.sendTransaction(setMarketModeTx, payer, []);
    });
}
setMarketMode();
//# sourceMappingURL=setMarketMode.js.map