"use strict";
// import { Commitment, Connection } from '@solana/web3.js';
// import { Market } from '@project-serum/serum';
// import { Config, Cluster, MangoClient, zeroKey } from '../..';
// import * as fs from 'fs';
// import * as path from 'path';
// /**
//  * Creates kubernetes configs for testnet clients, includes secrets and containers, writes to ./k8s
//  */
// async function createConfigs() {
//   const config = Config.ids();
//   const cluster = (process.env.CLUSTER || 'testnet') as Cluster;
//   const connection = new Connection(
//     config.cluster_urls[cluster],
//     'processed' as Commitment,
//   );
//   const groupName = process.env.GROUP || 'testnet.0';
//   const groupIds = config.getGroup(cluster, groupName)!;
//   const client = new MangoClient(connection, groupIds.mangoProgramId);
//   const group = await client.getMangoGroup(groupIds.publicKey);
//   const perpMarkets = await Promise.all(
//     groupIds.perpMarkets.map((perpMarket) => {
//       return group.loadPerpMarket(
//         connection,
//         perpMarket.marketIndex,
//         perpMarket.baseDecimals,
//         perpMarket.quoteDecimals,
//       );
//     }),
//   );
//   const spotMarkets = await Promise.all(
//     groupIds.spotMarkets.map((spotMarket) => {
//       return Market.load(
//         connection,
//         spotMarket.publicKey,
//         undefined,
//         groupIds.serumProgramId,
//       );
//     }),
//   );
//   // market maker and taker for each perp market
//   for (const perpMarket of perpMarkets) {
//     if (perpMarket.publicKey.equals(zeroKey)) {
//       continue;
//     }
//     const info = groupIds.perpMarkets.find((x) =>
//       x.publicKey.equals(perpMarket.publicKey),
//     )!;
//     const mmName = `marketmaker-${info.baseSymbol.toLowerCase()}-perp`;
//     const mmMangoAccountAddress =
//       '5Jetb3ZoZVXwCEAoNGbaGgBpdqT7Sq5ZAf1ZK5wp51vZ';
//     const mmConfig = `apiVersion: apps/v1
// kind: Deployment
// metadata:
//   namespace: mango
//   name: ${mmName}
//   labels:
//     app: marketmaker
//     cluster: testnet
//     marketType: perp
//     market: ${info.baseSymbol}_USDC
// spec:
//   replicas: 1
//   selector:
//     matchLabels:
//       app: ${mmName}
//   template:
//     metadata:
//       labels:
//         app: ${mmName}
//     spec:
//       containers:
//         - name: ${mmName}
//           image: gcr.io/robotic-tide-349212/mango-explorer:latest
//           imagePullPolicy: Always
//           terminationMessagePolicy: FallbackToLogsOnError
//           resources:
//             limits:
//               memory: 256Mi
//             requests:
//               memory: 64Mi
//           env:
//             - name: NODE_NAME
//               valueFrom:
//                 fieldRef:
//                   fieldPath: spec.nodeName
//           envFrom:
//             - secretRef:
//                 name: marketmaker
//             - configMapRef:
//                 name: cluster
//           command:
//             - marketmaker
//             - --account-address
//             - ${mmMangoAccountAddress}
//             - --name
//             - "${info.baseSymbol}-PERP Marketmaker ($(NODE_NAME))"
//             - --market
//             - perp:${info.baseSymbol}-PERP
//             - --update-mode
//             - POLL
//             - --oracle-provider
//             - ftx
//             - --hedging-market
//             - "${info.baseSymbol}/USDC"
//             - --hedging-target-balance
//             - "${info.baseSymbol}:10"
//             - --chain
//             - ratios
//             - --ratios-spread
//             - "0.005"
//             - --ratios-spread
//             - "0.010"
//             - --ratios-spread
//             - "0.015"
//             - --ratios-position-size
//             - "0.05"
//             - --ratios-position-size
//             - "0.07"
//             - --ratios-position-size
//             - "0.09"
//             - --chain
//             - minimumcharge
//             - --minimumcharge-ratio
//             - "0.001"
//             - --chain
//             - biasquoteonposition
//             - --biasquoteonposition-bias
//             - "0.00005"
//             - --chain
//             - roundtolotsize
//             - --redeem-threshold
//             - "1"
//             - --existing-order-tolerance
//             - "0.0001"
//             - --minimumcharge-ratio
//             - "0.0001"
//             - --pulse-interval
//             - "10"
//             - --order-type
//             - POST_ONLY_SLIDE
//             - --expire-seconds
//             - "15"
//             - --match-limit
//             - "10"
//             - --blockhash-cache-duration
//             - "30"
//             - --log-level
//             - DEBUG
//             - --log-suppress-timestamp
//           livenessProbe:
//             exec:
//               command:
//                 - file-age-check
//                 - "180"
//                 - /var/tmp/mango_healthcheck_marketmaker_pulse
//             initialDelaySeconds: 30
//             periodSeconds: 60
//             successThreshold: 1
//             failureThreshold: 3
//           readinessProbe:
//             exec:
//               command:
//                 - cat
//                 - /var/tmp/mango_healthcheck_marketmaker_pulse
//             initialDelaySeconds: 30
//             failureThreshold: 12
//             periodSeconds: 5
//       restartPolicy: Always
//       initContainers:
//         - name: ensure-openorders
//           image: gcr.io/robotic-tide-349212/mango-explorer:latest
//           imagePullPolicy: Always
//           terminationMessagePolicy: FallbackToLogsOnError
//           envFrom:
//             - secretRef:
//                 name: marketmaker
//             - configMapRef:
//                 name: cluster
//           command:
//             - ensure-open-orders
//             - --account-address
//             - ${mmMangoAccountAddress}
//             - --market
//             - perp:${info.baseSymbol}-PERP
//             - --log-level
//             - DEBUG
// `;
// const takerName = `random-taker-${info.baseSymbol.toLowerCase()}-perp`;
// const randomTakerConfig = `apiVersion: apps/v1
// kind: Deployment
// metadata:
//   namespace: mango
//   name: ${takerName}
//   labels:
//     app: random-taker
//     cluster: testnet
//     marketType: perp
//     market: "${info.baseSymbol}_USDC"
// spec:
//   replicas: 1
//   selector:
//     matchLabels:
//       app: ${takerName}
//   template:
//     metadata:
//       labels:
//         app: ${takerName}
//     spec:
//       containers:
//         - name: ${takerName}
//           image: gcr.io/robotic-tide-349212/mango-explorer:latest
//           imagePullPolicy: Always
//           terminationMessagePolicy: FallbackToLogsOnError
//           resources:
//             limits:
//               memory: 128Mi
//             requests:
//               memory: 16Mi
//           env:
//             - name: NODE_NAME
//               valueFrom:
//                 fieldRef:
//                   fieldPath: spec.nodeName
//           envFrom:
//             - secretRef:
//                 name: random-taker
//             - configMapRef:
//                 name: cluster
//           command:
//             - random-taker
//             - "${info.baseSymbol}-PERP"
//             - "0.6"
//             - "500"
//           livenessProbe:
//             exec:
//               command:
//                 - file-age-check
//                 - "180"
//                 - /var/tmp/mango_healthcheck_random_taker
//             initialDelaySeconds: 60
//             periodSeconds: 120
//             successThreshold: 1
//             failureThreshold: 3
//           readinessProbe:
//             exec:
//               command:
//                 - cat
//                 - /var/tmp/mango_healthcheck_random_taker
//             initialDelaySeconds: 120
//             failureThreshold: 12
//             periodSeconds: 5
//       restartPolicy: Always
//       initContainers:
//         - name: ensure-account
//           image: gcr.io/robotic-tide-349212/mango-explorer:latest
//           imagePullPolicy: Always
//           terminationMessagePolicy: FallbackToLogsOnError
//           envFrom:
//             - secretRef:
//                 name: random-taker
//             - configMapRef:
//                 name: cluster
//           command:
//             - ensure-account
//             - --wait
// `;
//     fs.writeFileSync(
//       path.resolve(__dirname, 'k8s', 'MarketMakers', mmName + '.yaml'),
//       mmConfig,
//     );
//     fs.writeFileSync(
//       path.resolve(__dirname, 'k8s', 'RandomTakers', takerName + '.yaml'),
//       randomTakerConfig,
//     );
//   }
//   // market maker and taker for each perp market
//   for (const spotMarket of spotMarkets) {
//     if (spotMarket.publicKey.equals(zeroKey)) {
//       continue;
//     }
//     const info = groupIds.spotMarkets.find((x) =>
//       x.publicKey.equals(spotMarket.publicKey),
//     )!;
//     const mmName = `marketmaker-${info.baseSymbol.toLowerCase()}-perp`;
//     //const mmMangoAccountAddress =
//     const mmConfig = `apiVersion: apps/v1
// kind: Deployment
// metadata:
//   namespace: mango
//   name: ${mmName}
//   labels:
//     app: marketmaker
//     cluster: testnet
//     marketType: perp
//     market: ${info.baseSymbol}_USDC
// spec:
//   replicas: 1
//   selector:
//     matchLabels:
//       app: ${mmName}
//   template:
//     metadata:
//       labels:
//         app: ${mmName}
//     spec:
//       containers:
//         - name: ${mmName}
//           image: gcr.io/robotic-tide-349212/mango-explorer:latest
//           imagePullPolicy: Always
//           terminationMessagePolicy: FallbackToLogsOnError
//           resources:
//             limits:
//               memory: 256Mi
//             requests:
//               memory: 64Mi
//           env:
//             - name: NODE_NAME
//               valueFrom:
//                 fieldRef:
//                   fieldPath: spec.nodeName
//           envFrom:
//             - secretRef:
//                 name: marketmaker
//             - configMapRef:
//                 name: cluster
//           command:
//             - marketmaker
//             - --account-address
//             - ${mmMangoAccountAddress}
//             - --name
//             - "${info.baseSymbol}-PERP Marketmaker ($(NODE_NAME))"
//             - --market
//             - perp:${info.baseSymbol}-PERP
//             - --update-mode
//             - POLL
//             - --oracle-provider
//             - ftx
//             - --hedging-market
//             - "${info.baseSymbol}/USDC"
//             - --hedging-target-balance
//             - "${info.baseSymbol}:10"
//             - --chain
//             - ratios
//             - --ratios-spread
//             - "0.005"
//             - --ratios-spread
//             - "0.010"
//             - --ratios-spread
//             - "0.015"
//             - --ratios-position-size
//             - "0.05"
//             - --ratios-position-size
//             - "0.07"
//             - --ratios-position-size
//             - "0.09"
//             - --chain
//             - minimumcharge
//             - --minimumcharge-ratio
//             - "0.001"
//             - --chain
//             - biasquoteonposition
//             - --biasquoteonposition-bias
//             - "0.00005"
//             - --chain
//             - roundtolotsize
//             - --redeem-threshold
//             - "1"
//             - --existing-order-tolerance
//             - "0.0001"
//             - --minimumcharge-ratio
//             - "0.0001"
//             - --pulse-interval
//             - "10"
//             - --order-type
//             - POST_ONLY_SLIDE
//             - --expire-seconds
//             - "15"
//             - --match-limit
//             - "10"
//             - --blockhash-cache-duration
//             - "30"
//             - --log-level
//             - DEBUG
//             - --log-suppress-timestamp
//           livenessProbe:
//             exec:
//               command:
//                 - file-age-check
//                 - "180"
//                 - /var/tmp/mango_healthcheck_marketmaker_pulse
//             initialDelaySeconds: 30
//             periodSeconds: 60
//             successThreshold: 1
//             failureThreshold: 3
//           readinessProbe:
//             exec:
//               command:
//                 - cat
//                 - /var/tmp/mango_healthcheck_marketmaker_pulse
//             initialDelaySeconds: 30
//             failureThreshold: 12
//             periodSeconds: 5
//       restartPolicy: Always
//       initContainers:
//         - name: ensure-openorders
//           image: gcr.io/robotic-tide-349212/mango-explorer:latest
//           imagePullPolicy: Always
//           terminationMessagePolicy: FallbackToLogsOnError
//           envFrom:
//             - secretRef:
//                 name: marketmaker
//             - configMapRef:
//                 name: cluster
//           command:
//             - ensure-open-orders
//             - --account-address
//             - ${mmMangoAccountAddress}
//             - --market
//             - perp:${info.baseSymbol}-PERP
//             - --log-level
//             - DEBUG
// `;
//   }
// }
// createConfigs();
//# sourceMappingURL=createKubernetesConfigs.js.map